;
;CLSID stands for "Class Identifier" and IID stands for "Interface Identifier".
;Both these IDs are in GUID ("Globally Unique Identifier") form. Each GUID
;is guaranteed by Windows to be unique, even if created by the user (provided
;it is created in the manner required by Windows).
;The GUID form is a structure 16 bytes long as follows:-
;
GUID STRUCT
    DD 0
    DW 0
    DW 0
    DB 0
    DB 7 DUP 0 
ENDS
;
;****************************************************************
;
;  The structures containing the names of the functions
;  of each COM object used
;  Note that these structures are never actually declared
;  in data, they serve merely to provide a number which
;  represents the correct offset to the function pointer
;  in the virtual table.  For example
;  IOleObject.IUnknown.QueryInterface resolves to 0h
;  IOleObject.SetHostNames resolves to 18h
;
UNKNOWN STRUCT
   QueryInterface DD 0
   AddRef         DD 0
   Release        DD 0
UNKNOWN ends
;
IOleObject STRUCT                  ;this VTable comes from Oleldl.h
IUnknown          UNKNOWN
SetClientSite     DD 0
GetClientSite     DD 0
SetHostNames      DD 0
Close             DD 0
SetMoniker        DD 0
GetMoniker        DD 0
InitFromData      DD 0
GetClipboardData  DD 0
DoVerb            DD 0
EnumVerbs         DD 0
Update            DD 0
IsUpToDate        DD 0
GetUserClassID    DD 0
GetUserType       DD 0
SetExtent         DD 0
GetExtent         DD 0
Advise            DD 0
Unadvise          DD 0
EnumAdvise        DD 0
GetMiscStatus     DD 0
SetColorScheme    DD 0
IOleObject ENDS
;
IWebBrowser2 STRUCT                ;this VTable comes from ExDisp.h
IUnknown          UNKNOWN
GetTypeInfoCount  DD 0
GetTypeInfo       DD 0
GetIDsOfNames     DD 0
Invoke            DD 0
GoBack            DD 0
GoForward         DD 0
GoHome            DD 0
GoSearch          DD 0
Navigate          DD 0
Refresh           DD 0
Refresh2          DD 0
Stop              DD 0
get_Application   DD 0
get_Parent        DD 0
get_Container     DD 0
get_Document      DD 0
get_TopLevelContainer DD 0
get_Type          DD 0
get_Left          DD 0
put_Left          DD 0
get_Top           DD 0
put_Top           DD 0
get_Width         DD 0
put_Width         DD 0
get_Height        DD 0
put_Height        DD 0
get_LocationName  DD 0
get_LocationURL   DD 0
get_Busy          DD 0
Quit              DD 0
ClientToWindow    DD 0
PutProperty       DD 0
GetProperty       DD 0
get_Name          DD 0
get_HWND          DD 0
get_FullName      DD 0
get_Path          DD 0
get_Visible       DD 0
put_Visible       DD 0
get_StatusBar     DD 0
put_StatusBar     DD 0
get_StatusText    DD 0
put_StatusText    DD 0
get_ToolBar       DD 0
put_ToolBar       DD 0
get_MenuBar       DD 0
put_MenuBar       DD 0
get_FullScreen    DD 0
put_FullScreen    DD 0
Navigate2         DD 0
QueryStatusWB     DD 0
ExecWB            DD 0
ShowBrowserBar    DD 0
get_ReadyState    DD 0
get_Offline       DD 0
put_Offline       DD 0
get_Silent        DD 0
put_Silent        DD 0
get_RegisterAsBrowser    DD 0
put_RegisterAsBrowser    DD 0
get_RegisterAsDropTarget DD 0
put_RegisterAsDropTarget DD 0
get_TheaterMode   DD 0
put_TheaterMode   DD 0
get_AddressBar    DD 0
put_AddressBar    DD 0
get_Resizable     DD 0
put_Resizable     DD 0
IWebBrowser2 ENDS
;
;------------------------------------------------------------------------
;
; CoInvoke MACRO making it easier to use the interfaces
; This makes use of GoAsm's ARGCOUNT
; ARGCOUNT is an assemble-time counter returning the number
; of arguments known to GoAsm when INVOKE is used
;
;------------------------------------------------------------------------
;
CoInvoke(%o,%p,%a,%b,%c,%d,%e,%f,%g,%h,%i,%j,%k,%l) MACRO
            #if ARGCOUNT == 14
            PUSH %l
            #endif
            #if ARGCOUNT >= 13
            PUSH %k
            #endif
            #if ARGCOUNT >= 12
            PUSH %j
            #endif
            #if ARGCOUNT >= 11
            PUSH %i
            #endif
            #if ARGCOUNT >= 10
            PUSH %h
            #endif
            #if ARGCOUNT >= 9
            PUSH %g
            #endif
            #if ARGCOUNT >= 8
            PUSH %f
            #endif
            #if ARGCOUNT >= 7
            PUSH %e
            #endif
            #if ARGCOUNT >= 6
            PUSH %d
            #endif
            #if ARGCOUNT >= 5
            PUSH %c
            #endif
            #if ARGCOUNT >= 4
            PUSH %b
            #endif
            #if ARGCOUNT >= 3
            PUSH %a
            #endif
            mov eax,[%o]
            push eax
            mov eax,[eax]
            call [eax+%p]
ENDM

