;
; WebSkel2.asm by Jeremy Gordon May 2007
; This file has what appears to be the minimum code required to create a WebBrowser control.
; WebSkel1.asm creates a basic window to hold the control.
;
; Assemble using GoAsm WebSkel2
; This creates WebSkel1.obj
; Then link using ..
; Golink WebSkel1.obj WebSkel2.obj /fo WebSkel.exe /debug coff kernel32.dll user32.dll ole32.dll
;                     (or use a command file eg. GoLink @respons.fil)
;
#include WebSkel.inc
;
OLEIVERB_SHOW = -1
;
;*******************************************************************
;
DATA
;
;*******************************************************************
;
;*** see WebSkel.inc for the GUID structure
;
IID_IUnknown GUID <0,0,0,0C0h,<0,0,0,0,0,0,46h>>
IID_IOleClientSite GUID <118h,0h,0h,0C0h,<0h,0h,0h,0h,0h,0h,46h>>
IID_IOleInPlaceSite GUID <119h,0h,0h,0C0h,<0h,0h,0h,0h,0h,0h,46h>>
IID_IOleObject GUID <112h,0h,0h,0C0h,<0h,0h,0h,0h,0h,0h,46h>>
IID_IWebBrowser2 GUID <0D30C1661h,0CDAFh,11D0h,8Ah,<3Eh,0,0C0h,4Fh,0C9h,0E2h,6Eh>>
CLSID_WebBrowser GUID <8856F961h,340Ah,11D0h,0A9h,<6Bh,0h,0C0h,4Fh,0D7h,5h,0A2h>>
;
;******* here is the IStorage VTable (Virtual Table)
IStorageTable DD Storage_QueryInterface
              DD Storage_AddRef  
              DD Storage_Release 
              DD Storage_CreateStream      
              DD Storage_OpenStream        
              DD Storage_CreateStorage     
              DD Storage_OpenStorage       
              DD Storage_CopyTo            
              DD Storage_MoveElementTo     
              DD Storage_Commit            
              DD Storage_Revert            
              DD Storage_EnumElements      
              DD Storage_DestroyElement    
              DD Storage_RenameElement     
              DD Storage_SetElementTimes   
              DD Storage_SetClass          
              DD Storage_SetStateBits      
              DD Storage_Stat              
;******* here is the IStorage structure which is merely a pointer to the IStorage VTable
IStorage DD IStorageTable 
;
;******* here is the IOleInPlaceFrameTable VTable
IOleInPlaceFrameTable DD Frame_QueryInterface
                      DD Frame_AddRef
                      DD Frame_Release
                      DD Frame_GetWindow
                      DD Frame_ContextSensitiveHelp
                      DD Frame_GetBorder
                      DD Frame_RequestBorderSpace
                      DD Frame_SetBorderSpace
                      DD Frame_SetActiveObject
                      DD Frame_InsertMenus
                      DD Frame_SetMenu
                      DD Frame_RemoveMenus
                      DD Frame_SetStatusText
                      DD Frame_EnableModeless
                      DD Frame_TranslateAccelerator
;******************************************************
;
;******* here is the IOleClientSite VTable
IOleClientSiteTable DD ClientSite_QueryInterface
                    DD ClientSite_AddRef
                    DD ClientSite_Release
                    DD ClientSite_SaveObject
                    DD ClientSite_GetMoniker
                    DD ClientSite_GetContainer
                    DD ClientSite_ShowObject
                    DD ClientSite_OnShowWindow
                    DD ClientSite_RequestNewObjectLayout
;******************************************************
;
;******* here is the IOleInPlaceSite VTable
IOleInPlaceSiteTable DD InPlaceSite_QueryInterface
                     DD InPlaceSite_AddRef
                     DD InPlaceSite_Release
                     DD InPlaceSite_GetWindow
                     DD InPlaceSite_ContextSensitiveHelp
                     DD InPlaceSite_CanInPlaceActivate
                     DD InPlaceSite_OnInPlaceActivate
                     DD InPlaceSite_OnUIActivate
                     DD InPlaceSite_GetWindowContext
                     DD InPlaceSite_Scroll
                     DD InPlaceSite_OnUIDeactivate
                     DD InPlaceSite_OnInPlaceDeactivate
                     DD InPlaceSite_DiscardUndoState
                     DD InPlaceSite_DeactivateAndUndo
                     DD InPlaceSite_OnPosRectChange
;******************************************************
;
IWEBBROWSER2 DD 0       ;holds IWebBrowser2 from time to time
RECT DD 4 DUP 0
VARIANT_BSTR DW 8         ;+0 typeflag (BSTR string)
             DW 0         ;+2 reserved
             DW 0         ;+4 reserved
             DW 0         ;+6 reserved
             DD 0         ;+8 pointer to BSTR
;******************************************************
;
CODE
;
;*******************************************************************
;
;********************************************************************************************
;
; Here are the Storage functions (nothing much happens here).
;
;********************************************************************************************
;
Storage_QueryInterface:
Storage_RenameElement:
Storage_SetStateBits:
Storage_Stat:
MOV EAX,80004001h       ;NOTIMPLEMENTED
RET 0Ch
;
Storage_AddRef:
Storage_Release:
MOV EAX,1
RET 4
;
Storage_CreateStream:
Storage_OpenStream:
Storage_CreateStorage:
MOV EAX,80004001h       ;NOTIMPLEMENTED
RET 18h
;
Storage_OpenStorage:
MOV EAX,80004001h       ;NOTIMPLEMENTED
RET 1Ch
;
Storage_CopyTo:
Storage_MoveElementTo:
Storage_EnumElements:
Storage_SetElementTimes:
MOV EAX,80004001h       ;NOTIMPLEMENTED
RET 14h
;
Storage_Commit:
Storage_DestroyElement:
MOV EAX,80004001h       ;NOTIMPLEMENTED
RET 8
;
Storage_Revert:
MOV EAX,80004001h       ;NOTIMPLEMENTED
RET 4
;
Storage_SetClass:
XOR EAX,EAX             ;S_OK
RET 8
;
;********************************************************************************************
;
; Here are the IOleInPlaceFrame functions
; ESP is used to access the parameters sent by the system to these functions.
; Instead it would be possible to create a stack frame using FRAME..ENDF.
;
;********************************************************************************************
;
Frame_QueryInterface:
MOV EAX,80004001h       ;NOTIMPLEMENTED
RET 0Ch
;
Frame_AddRef:
Frame_Release:
MOV EAX,1
RET 4
;
Frame_GetWindow:
MOV EAX,[ESP+4]         ;get first param ("This")
MOV ECX,[EAX+4]         ;get window handle kept in interface
MOV EDX,[ESP+8]         ;get second param ("phwnd")
MOV [EDX],ECX           ;and insert handle in phwnd
XOR EAX,EAX             ;S_OK
RET 8
;
Frame_ContextSensitiveHelp:
Frame_GetBorder:
Frame_RequestBorderSpace:
Frame_SetBorderSpace:
Frame_RemoveMenus:
MOV EAX,80004001h       ;NOTIMPLEMENTED
RET 8
;
Frame_SetActiveObject:
XOR EAX,EAX             ;S_OK
RET 0Ch
;
Frame_InsertMenus:
Frame_TranslateAccelerator:
MOV EAX,80004001h       ;NOTIMPLEMENTED
RET 0Ch
;
Frame_SetMenu:
XOR EAX,EAX             ;S_OK
RET 10h
;
Frame_SetStatusText:
Frame_EnableModeless:
XOR EAX,EAX             ;S_OK
RET 8
;
;
;********************************************************************************************
;
; Here are the IOleClientSite functions
; ESP is used to access the parameters sent by the system to these functions.
; Instead it would be possible to create a stack frame using FRAME..ENDF.
;
;********************************************************************************************
;
; Remember, the interface we created in EmbedBrowserObject is as follows:-
; +0   Pointer to IWebBrowser
; +4   Pointer to VTable for IOleInPlaceFrame
; +8   Handle of owner window
; +C   Pointer to VTable for IOleClientSite
; +10  Pointer to VTable for IOleInPlaceSite
; +14  Pointer to value at +4 (pointer to VTable for IOleInPlaceFrame)
;
; The returns from this function are those in Jeff Glatt's plain C example of 
; embedding a web browser control in an application.  See "Display a web page 
; in a plain C Win32 application".  Unlike in that file, however, I have not 
; also brought InPlaceSite_QueryInterface here.  It's not clear to me that it
; is correct to do so.
; See also Chris Becke's C++ minimum example in the file webhost.cab.
;
; On the basis that only IOleClientSite calls this function, then it does this ..
; 1. If the caller is asking for IUnknown, return the interface of the caller 
;    (IOleClientSite).
; 2. If the caller is asking for IOleClientSite, return the interface of the 
;    caller (IOleClientSite).
; 3. If the caller is asking for IOleInPlaceSite, return the pointer in the 
;    following dword. (IOleInPlaceSite).
; 4. Otherwise return NO_INTERFACE.
;
ClientSite_QueryInterface:
MOV EAX,[ESP+8]         ;get second param ("riid")
MOV EDX,[ESP+0Ch]       ;get third param ("ppvObject")
PUSH ESI,EDI
;***** first, see if the caller is asking for IUnknown
MOV ECX,4
MOV EDI,ADDR IID_IUnknown
MOV ESI,EAX
REPZ CMPSD              ;compare the GUIDs
JZ >L40                 ;the same, so answer is "yes"
;***** next, see if the caller is asking for IOleClientSite
MOV ECX,4
MOV EDI,ADDR IID_IOleClientSite
MOV ESI,EAX
REPZ CMPSD              ;compare the GUIDs
JZ >L40                 ;the same, so answer is "yes"
;***** next, see if the caller is asking for IOleInPlaceSite
MOV ECX,4
MOV EDI,ADDR IID_IOleInPlaceSite
MOV ESI,EAX
REPZ CMPSD              ;compare the GUIDs
JNZ >L30                ;not the same
MOV ECX,[ESP+0Ch]       ;get first param ("This") 
ADD ECX,4               ;get to IOleInPlaceSite
XOR EAX,EAX             ;return S_OK
JMP >L42
L30:
XOR ECX,ECX             ;ready to zero ppvObject
MOV EAX,80004002h       ;return NO_INTERFACE
JMP >L42
L40:
MOV ECX,[ESP+0Ch]       ;get first param ("This")
XOR EAX,EAX             ;return S_OK
L42:
MOV [EDX],ECX           ;insert result in ppvObject
POP EDI,ESI
RET 0Ch
;
ClientSite_AddRef:
ClientSite_Release:
MOV EAX,1
RET 4
;
ClientSite_SaveObject:
ClientSite_RequestNewObjectLayout:
MOV EAX,80004001h       ;NOTIMPLEMENTED
RET 4
;
ClientSite_GetMoniker:
MOV EAX,80004001h       ;NOTIMPLEMENTED
RET 10h
;
ClientSite_GetContainer:
MOV EAX,[ESP+8]         ;get second param ("ppContainer")
MOV D[EAX],0            ;zero it for caller
MOV EAX,80004002h       ;return NO_INTERFACE
RET 8
;
ClientSite_ShowObject:
XOR EAX,EAX             ;return NO_ERROR
RET 4
;
ClientSite_OnShowWindow:
MOV EAX,80004001h       ;NOTIMPLEMENTED
RET 8
;
;********************************************************************************************
;
; Here are the IOleInPlaceSite functions
; ESP is used to access the parameters sent by the system to these functions.
; Instead it would be possible to create a stack frame using FRAME..ENDF.
;
;********************************************************************************************
;
InPlaceSite_QueryInterface:
MOV EAX,80004001h       ;NOTIMPLEMENTED
RET 0Ch
;
InPlaceSite_AddRef:
InPlaceSite_Release:
MOV EAX,1
RET 4
;
InPlaceSite_GetWindow:
MOV EAX,[ESP+4]         ;get first param ("This")
MOV ECX,[EAX+4]         ;get interface
MOV ECX,[ECX+4]         ;get the window handle
MOV EAX,[ESP+8]         ;get second param ("phwnd")
MOV [EAX],ECX           ;and insert handle in phwnd
XOR EAX,EAX             ;return S_OK
RET 8
;
InPlaceSite_ContextSensitiveHelp:
InPlaceSite_Scroll:
MOV EAX,80004001h       ;NOTIMPLEMENTED
RET 8
;
InPlaceSite_CanInPlaceActivate:
InPlaceSite_OnInPlaceActivate:
InPlaceSite_OnUIActivate:
InPlaceSite_OnInPlaceDeactivate:
XOR EAX,EAX             ;S_OK
RET 4
;
;According to the SDK, this function "enables the in-place object to retrieve 
;the window interfaces that form the the window object hierarchy, and the
;position in the parent window where the object's in-place activation
;window should be placed".
;Ie. when this function is called by the system it positions the WebBrowser 
;control in its owner.
;
;Parameters are:-
;This         interface being called
;ppFrame      receives pointer to IOleInPlaceFrame
;ppDoc        receives pointer to IOleInPlaceUIWindow
;lprcPosRect  points to position of in-place object
;lprcClipRect points to in-place object's position rectangle
;lpFrameInfo  pointer to OLEINPLACEFRAME structure
InPlaceSite_GetWindowContext:
PUSH ESI,EDI
MOV EDX,[ESP+14h]       ;get third param ("ppDoc")
MOV ESI,[ESP+20h]       ;get sixth param ("lpFrameInfo")
;***** zero parts of OLEINPLACEFRAME structure
XOR ECX,ECX             ;zero ecx
MOV [ESI+4],ECX
MOV [ESI+0Ch],ECX
MOV [ESI+10h],ECX
;*****
MOV [EDX],ECX           ;zero pDoc
;*****
MOV EAX,[ESP+0Ch]       ;get first param ("This")
MOV ECX,[EAX+4]         ;get pointer to VTable of IOleInPlaceFrame inserted by EmbedBrowserObject
MOV EAX,[ESP+10h]       ;get second param ("ppFrame")
MOV [EAX],ECX           ;insert pointer to VTable of IOleInPlaceFrame
MOV EDI,[ECX+4]         ;get owner's window handle inserted by EmbedBrowserObject
MOV [ESI+8],EDI         ;insert owner's window handle in OLEINPLACEFRAME structure
PUSH [ESP+18h],EDI      ;fourth param ("lprcPosRect"),edi=owner's window handle
CALL GetClientRect      ;get dimensions of owner window into lprcPosRect
PUSH [ESP+1Ch],EDI      ;fifth param ("lprcClipRect"),edi=owner's window handle
CALL GetClientRect      ;get dimensions of owner window into lprcClipRect
XOR EAX,EAX             ;S_OK
POP EDI,ESI
RET 18h
;
InPlaceSite_OnUIDeactivate:
InPlaceSite_OnPosRectChange:
XOR EAX,EAX             ;S_OK
RET 8
;
InPlaceSite_DiscardUndoState:
InPlaceSite_DeactivateAndUndo:
MOV EAX,80004001h       ;NOTIMPLEMENTED
RET 4
;
;******************************************************************************************
UnEmbedBrowserObject:   ;window handle in eax
PUSH -21,EAX            ;21=GWL_USERDATA, eax=window handle
CALL GetWindowLongA     ;get interface for this window held as window data
OR EAX,EAX              ;see if failed
JZ >.error              ;yes
MOV EDI,EAX
CoInvoke(EDI,IOleObject.Close,1)
CoInvoke(EDI,IOleObject.IUnknown.Release)
INVOKE GlobalFree,EDI
.error:
RET
;
;******************************************************************************************
;
DisplayHTMLPage:        ;arrives with eax=hWnd, esi=url
PUSH -21,EAX            ;21=GWL_USERDATA, eax=window handle
CALL GetWindowLongA     ;get interface for this window held as window data
OR EAX,EAX              ;see if failed
JZ >.error              ;yes
;********************* get the IWebBrowser2 interface
CoInvoke(EAX,IOleObject.IUnknown.QueryInterface,ADDR IID_IWebBrowser2,ADDR IWEBBROWSER2)
TEST EAX,EAX            ;see if error
JS >.error              ;yes
MOV EBX,ADDR VARIANT_BSTR      ;get variant of type BSTR declared in data
MOV [EBX+8h],ESI        ;insert string in variant
;********************* navigate browser to the caller's url and then release interface
CoInvoke(IWEBBROWSER2,IWebBrowser2.Navigate2,EBX,0,0,0,0)
CoInvoke(IWEBBROWSER2,IWebBrowser2.IUnknown.Release)
CLC                     ;return nc if success
RET
.error:
STC                     ;return c if error
RET
;
; Here we create an interface in system memory as follows:-
; +0   Pointer to IWebBrowser
; +4   Pointer to VTable for IOleInPlaceFrame
; +8   Handle of owner window
; +C   Pointer to VTable for IOleClientSite
; +10  Pointer to VTable for IOleInPlaceSite
; +14  Pointer to value at +4 (pointer to VTable for IOleInPlaceFrame)
;
EmbedBrowserObject:     ;window handle of owner is in ebx
;***** allocate memory to store the pointer to the browser object
PUSH 18h,0              ;size of interface to be made, GMEM_FIXED
CALL GlobalAlloc
OR EAX,EAX              ;see if failed to make memory
JNZ >L10                ;no
L8:
STC                     ;yes, so return c
RET
L10:
MOV EDI,EAX             ;keep memory just made in edi
;********* now fill the interface
MOV [EDI+4h],ADDR IOleInPlaceFrameTable   ;insert pointer to this VTable into 2nd dword
MOV [EDI+8h],EBX        ;insert window handle into 3rd dword
MOV [EDI+0Ch],ADDR IOleClientSiteTable    ;insert pointer to this VTable into 4th dword
MOV [EDI+10h],ADDR IOleInPlaceSiteTable   ;insert pointer to this VTable into 5th dword
ADD EAX,4
MOV [EDI+14h],EAX       ;insert pointer to the pointer to IOleInPlaceFrameTable into the 6th dword
;********* now get IWebBrowser
PUSH EDI                ;place to receive pointer to IWebBrowser (top of interface)
PUSH ADDR IStorage      ;address of home-made IStorage
ADD EAX,8               ;get eax to pointer to pointer to IOleClientSiteTable
PUSH EAX                ;push pointer to pointer to IOleClientSiteTable
PUSH 0
PUSH 1                  ;OLERENDER_DRAW
PUSH ADDR IID_IOleObject
PUSH ADDR CLSID_WebBrowser
CALL OleCreate
OR EAX,EAX              ;see if failed
JNZ >.fail2             ;yes
;********* keep interface in userdata of owning window for easy access
INVOKE SetLastError,0   ;clear the last error code
PUSH EDI                ;interface pointer
PUSH -21,EBX            ;21=GWL_USERDATA, EBX=window handle sent by caller
CALL SetWindowLongA     ;keep interface pointer in Window's userdata
OR EAX,EAX              ;check what may be last userdata value
JNZ >L12                ;it's not zero - success
INVOKE GetLastError     ;it's zero
OR EAX,EAX              ;see if there really was an error
JNZ >.fail1             ;yes, there was
L12:
;****************************************************** not sure why this is needed
PUSH 1,[EDI]            ;TRUE, IWebBrowser   
CALL OleSetContainedObject    ;tell object that it is embedded in an OLE container
OR EAX,EAX
JNZ >.fail1
;********************** now actually put browser control into the window
;********************** by calling IOleObject::DoVerb
MOV EDX,EDI
ADD EDX,0Ch             ;get to pointer to IOleClientSiteTable
CoInvoke(EDI,IOleObject.DoVerb,OLEIVERB_SHOW,0,EDX,0,EBX,ADDR RECT)
TEST EAX,EAX
JS >.fail1
CLC                     ;return success
RET
.fail1:
CoInvoke(EDI,IOleObject.Close,1)
CoInvoke(EDI,IOleObject.IUnknown.Release)
JMP >L60                ;let the system release the memory at its leisure
.fail2:
INVOKE GlobalFree,EDI   ;free the memory used in the interface
L60:
STC
RET
;    
